﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Xml.Serialization;
using System.Xml.Linq;
using System.Xml;

namespace RIATaskApplication.Web
{
    /// <summary>
    /// Summary description for POXTasks
    /// </summary>
    public class POXTasks : IHttpHandler
    {

        public void ProcessRequest(HttpContext context)
        {
            context.Response.ClearContent();
            context.Response.ContentType = "text/xml";

            if (context.Request.HttpMethod == "GET")
            {
                Tasks.DAL.TaskDBEntities ctx =
                    new Tasks.DAL.TaskDBEntities();

                var root = new XElement("Tasks",
                            (from t in ctx.Tasks.ToList()

                             select new XElement("Task",
                                 new XElement("Description",
                                     t.Description),
                                 new XElement("DueDate", t.DueDate)
                             )

                            ));
                var writer = XmlWriter.Create(
                    context.Response.OutputStream);
                root.WriteTo(writer);
                writer.Flush();
                context.Response.Flush();

                
            }
            
        }

        public bool IsReusable
        {
            get
            {
                return false;
            }
        }
    }
}