﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel;

namespace TaskHost
{
    class Program
    {
        static void Main(string[] args)
        {
            ServiceHost host =
                new ServiceHost(typeof(TaskService),
                    new Uri("http://localhost:8732/Tasks/"));

            host.AddServiceEndpoint(
                "TaskServiceLibrary.ITaskService",
                new BasicHttpBinding(),
                "");

            var tcpBinding = new NetTcpBinding();
            tcpBinding.Security.Mode = SecurityMode.None;

            host.AddServiceEndpoint(
                  "TaskServiceLibrary.ITaskService",
                  tcpBinding,
                  "net.tcp://localhost:8733/Tasks/");

            try{
                host.Open();
                PrintDescription(host);
                Console.ReadLine();
            }
            catch(Exception ex)
            {
                if(host != null)
                {
                    if(host.State == CommunicationState.Opened)
                        host.Close();
                    else
                        host.Abort();
                }

                Console.WriteLine(ex.Message);
                Console.ReadLine();
            }

        }

        private static void PrintDescription(ServiceHost host)
        {
            foreach (var item in host.Description.Endpoints)
            {
                Console.WriteLine(item.Address);
            }
        }
    }


}
