﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using TaskServiceLibrary;

namespace TaskHost
{
    public class TaskService : ITaskService
    {
        InMemoryTaskRepository repo = new InMemoryTaskRepository();


        public void SubmitTask(Task task)
        {
            repo.AddTask(task);
            Console.WriteLine("{0}:{1}",
                task.Subject, task.AssignedTo);
        }

        public List<Task> GetTasks()
        {
            return repo.GetTasks().ToList();
        }

        public List<Task> GetTasksForUser(string userName)
        {
            return (from t in repo.GetTasks()
                   from u in repo.GetUsers()
                   where u.UserName == userName
                   && u.UserID == t.AssignedTo
                   select t).ToList();
        }
    }
}
