﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace TaskMVC.Controllers
{
    public class TaskController : Controller
    {
        //
        
        public ActionResult JSON(int? id)
        {
            //get task or list of tasks
            return Json(GetTaskOrTasks(id), JsonRequestBehavior.AllowGet);
            
        }

        private object GetTaskOrTasks(int? id)
        {
            if (id.HasValue)
            {
                var task = new TaskServiceLibrary.DBTaskRepository().GetTasks().SingleOrDefault(t => t.TaskId == id.Value);
                return task;
            }
            else
            {
                var tasks = new TaskServiceLibrary.DBTaskRepository().GetTasks();
                return tasks;
            }
        }

        //
        // GET: /Task/(5)
        [HttpGet]
        public ActionResult Index(int? id)
        {
            if (id.HasValue)
            {
                //Get Task
                return View(GetTaskOrTasks(id));
            }
            else
            {
                return View("List", GetTaskOrTasks(id));
            }
            
        }

        

        //
        // POST: /Task

        [HttpPost]
        public ActionResult Index(TaskServiceLibrary.Task model)
        {
            try
            {
                // TODO: Add insert logic here
                if (ModelState.IsValid)
                {
                    new TaskServiceLibrary.DBTaskRepository().AddTask(model);
                    return RedirectToAction("Index");
                }
                else
                {
                    return View();
                }
            }
            catch
            {
                return View();
            }
        }
         

        //
        // PUT: /Task/5

        [HttpPut]
        public ActionResult Index(int id, TaskServiceLibrary.Task model)
        {
            try
            {
                // TODO: Add update logic here
                if (ModelState.IsValid)
                {
                    new TaskServiceLibrary.DBTaskRepository().UpdateTask(model);
                }
                return RedirectToAction("Index", new { id = id });
            }
            catch
            {
                return View();
            }
        }

        

        //
        // DELETE: /Task/5

        [HttpDelete]
        public ActionResult Index(int id)
        {
            try
            {
                // TODO: Add delete logic here
                new TaskServiceLibrary.DBTaskRepository().DeleteTask(id);
                return RedirectToAction("Index");
            }
            catch
            {
                return View();
            }
        }
    }
}
