﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace TaskServiceLibrary
{
    public class DBTaskRepository : ITaskRepository
    {


        public IQueryable<Task> GetTasks()
        {
            Tasks.DAL.TaskDBEntities ctx = new Tasks.DAL.TaskDBEntities();
            var query = from t in ctx.Tasks
                        select new Task
                        {
                            TaskId = t.TaskID,
                            Subject = t.Description,
                            DueDate = t.DueDate,
                            AssignedTo = t.AssignedTo
                        };

            return query;
        }

        public void AddTask(Task newTask)
        {
            using (Tasks.DAL.TaskDBEntities ctx = new Tasks.DAL.TaskDBEntities())
            {
                ctx.AddToTasks(new Tasks.DAL.Task
                {
                    AssignedTo = newTask.AssignedTo,
                    DueDate = newTask.DueDate,
                    Description = newTask.Subject
                });
                ctx.SaveChanges();
            }
        }

        public void DeleteTask(int toBeDeleted)
        {
            using (Tasks.DAL.TaskDBEntities ctx = new Tasks.DAL.TaskDBEntities())
            {
                var t = ctx.Tasks.SingleOrDefault(task => task.TaskID == toBeDeleted);
                if (t != null)
                {
                    ctx.DeleteObject(t);
                    ctx.SaveChanges();
                }
            }

        }

        public void UpdateTask(Task newTask)
        {
            using (Tasks.DAL.TaskDBEntities ctx = new Tasks.DAL.TaskDBEntities())
            {
                var t = ctx.Tasks.SingleOrDefault(task => task.TaskID == newTask.TaskId);
                if (t != null)
                {
                    t.AssignedTo = newTask.AssignedTo;
                    t.DueDate = newTask.DueDate;
                    t.Description = newTask.Subject;

                    ctx.SaveChanges();
                }
            }
        }


       
        public IQueryable<User> GetUsers()
        {
            Tasks.DAL.TaskDBEntities ctx = new Tasks.DAL.TaskDBEntities();
            return from u in ctx.Users
                   select new User
                   {
                       UserID = u.UserID,
                       UserName = u.UserName,
                       Email = u.Email
                   };
        }

        
    }
}
