﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace TaskServiceLibrary
{
    public class InMemoryTaskRepository : ITaskRepository
    {
        static List<Task> tasks = new List<Task>();
        static List<User> users = new List<User>
        {
            new User{UserName="Fred", Email="fred@contoso.com",
                UserID=1},
            new User{UserName="Jenny", Email="jenny@contoso.com",
                UserID=1},
            new User{UserName="Patricia", Email="patricia@contoso.com",
                UserID=1},

        };

        public IQueryable<User> GetUsers()
        {
            return users.AsQueryable();
        }
        public IQueryable<Task> GetTasks()
        {
            return tasks.AsQueryable();
        }

        public void AddTask(Task newTask)
        {
            tasks.Add(newTask);
        }

        public void DeleteTask(int toBeDeleted)
        {
            var t = tasks.SingleOrDefault(task => task.TaskId == toBeDeleted);
            if (t != null)
                tasks.Remove(t);
        }

        public void UpdateTask(Task newTask)
        {
            var t = tasks.SingleOrDefault(task => task.TaskId == newTask.TaskId);
            if (t != null)
            {
                t.AssignedTo = newTask.AssignedTo;
                t.DueDate = newTask.DueDate;
                t.Subject = newTask.Subject;
            }
        }
    }
}
